package massim.agent.implementation;

import massim.agent.framework.AbstractSyncAgent;
import massim.agent.framework.MessageContent;
import massim.agent.framework.StringContent;

import org.w3c.dom.Element;

public class ExampleSyncAgent extends AbstractSyncAgent {

    public ExampleSyncAgent(String username, String password) {
        super(username, password);
    }
    // some notes on usage:

    @Override
    public void processLogIn() {
        super.processLogIn();
        // called as soon as agent logged in successfully
        // TODO: insert code here
    }

    @Override
    public void processSimulationEnd(Element perception, long currenttime) {
        super.processSimulationEnd(perception, currenttime);
        // react on simulation end
        // TODO: insert code here
    }

    @Override
    public void processSimulationStart(Element perception, long currenttime) {
        super.processSimulationStart(perception, currenttime);
        // react on simulation start
        // TODO: insert code here
    }

    public void deliberate(Element perception, Element target, long currenttime, long deadline) {
        // react to normal perception, modify target so that it becomes a valid action

        // an example of a communication action
        for (int i = 0; i < 100; i++) {
            broadcastMessage(new StringContent(username + " says hello " + i + " to all in step #" + getSimStep(), getSimStep()));
            //sendMessage(new StringContent(username + " says hello to agent b1!" + i, stepCounter), "b1");
            Thread.yield();
        }

        while (!isEmptyInbox()) {

            Thread.yield();

            MessageContent msg = popInboxMessage();
            System.out.println(username + " received a message: \"" + msg.toString() + "\" in step #" + getSimStep());

            if (msg.getTimestamp() == getSimStep()) {
                //*************************************************************************
                //TODO: process the message
                //*************************************************************************
            } else {
                // handle messages with wrong timestamps
                Thread.yield();
                if (msg.getTimestamp() < getSimStep()) {
                    System.out.println(username + " throws away the message \"" + msg.toString() + "\" as too old");
                    continue;
                } else if (msg.getTimestamp() > getSimStep()) {
                    System.out.println(username + " resends the message \"" + msg.toString() + "\" to future self");
                    sendMessage(msg, username);
                    continue;
                }
            }
        }

        // TODO: insert code here!
        target.setAttribute("type", "right");

    }

    // the main entry point into the agent deliberation loop
    @Override
    public void run() {
        // you can configure the agent's connection point
        run("localhost", 12300);
    }

    @Override
    protected void runSyncAgent() {
        // TODO Auto-generated method stub
    }
}
